<?php

/**
 * @file
 * Definition of views_handler_relationship_entity_reverse_gcc.
 */

/**
 * A relationship handlers which reverse entity references.
 *
 * @ingroup views_relationship_handlers
 */
class views_handler_relationship_gcc_membership_information extends views_handler_relationship  {

  function init(&$view, &$options) {

    parent::init($view, $options);
  }

  /**
   * Called to implement a relationship in a query.
   */
  function query() {

    $this->ensure_my_table();

    // First, relate position node table to the current membership table.
    $first = array(

      'left_table' => $this->table_alias,
      'left_field' => 'uid',
      'table' => $this->definition['base'],
      'field' => $this->definition['base field'],
      'type' => 'INNER',
    );
    $first_join = new views_join();
    $first_join->definition = $first;
    $first_join->construct();
    $first_join->adjusted = TRUE;

    $this->first_alias = $this->query->add_table('position', $this->relationship, $first_join);

    // Second, relate the field table to the entity specified using
    // the entity id on the field table and the entity's id field.
    $second = array(

      'left_table' => $this->first_alias,
      'left_field' => 'nid', // @fixme : todo.
      'alias' => $this->definition['group_ref_field'] . '_' . $this->table,
      'table' => $this->definition['group_ref_field'],
      'field' => 'entity_id',
      'type' => 'INNER',
    );

    $second['extra'] = array(

      $second['alias'] . '.entity_type = \'node\'', // @fixme : todo.
      $second['alias'] . '.' . $this->definition['group_ref_field_column'] . ' = ' . $this->table_alias . '.entity_id',
    );

    $second['extra'] = implode(' AND ', $second['extra']);
    $second_join = new views_join();
    $second_join->definition = $second;
    $second_join->construct();
    $second_join->adjusted = TRUE;

    // Use a short alias for this.
    $this->query->add_relationship($second['alias'], $second_join, $this->definition['base'], $this->relationship);

    $this->alias = $this->first_alias;
  }
}
