<?php

/**
 * @file
 * TODO.
 */

$plugin = array(

  'title' => t("GCC group: content's group member"),
  'description' => t('Control access by the user membership state.'),
  'callback' => 'gcc_panels_gcc_content_group_member_access_check',
  'summary' => 'gcc_panels_gcc_content_group_member_access_summary',
  'required context' => new ctools_context_required(t('Group content'), 'entity'),
);

/**
 * Check for access.
 */
function gcc_panels_gcc_content_group_member_access_check($conf, $context, $plugin) {
  global $user;

  if (empty($context->data)) {
    return FALSE;
  }
  $entity = $context->data;

  if (!isset($entity->{GCC_FIELD_AUDIENCE})) {
    return FALSE;
  }

  foreach ($entity->{GCC_FIELD_AUDIENCE} as $values) {
    foreach ($values as $value) {
      $group_entity_type = $value['entity_type'];
      $group_entity_id = $value['entity_id'];
      if (gcc_membership_is_active($group_entity_type, $group_entity_id, $user->uid)) {
        return TRUE;
      }
    }
  }

  return FALSE;
}

/**
 * Provide a summary description.
 */
function gcc_panels_gcc_content_group_member_access_summary($conf, $context) {
  return t("Current user is member of the content's group.");
}
