<?php

/**
 * @file
 * TODO.
 */

$plugin = array(

  'title' => t('GCC group: member'),
  'description' => t('Control access by the user membership state.'),
  'callback' => 'gcc_panels_gcc_group_member_access_check',
  'summary' => 'gcc_panels_gcc_group_member_access_summary',
  'get child' => 'gcc_panels_gcc_group_member_access_get_child',
  'get children' => 'gcc_panels_gcc_group_member_access_get_children',
);

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_member_access_get_child($plugin, $parent, $child) {

  $plugins = gcc_panels_gcc_group_member_access_get_children($plugin, $parent);

  return $plugins[$parent . ':' . $child];
}

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_member_access_get_children($plugin, $parent) {

  $plugins = array();
  $group_entities = array_keys(gcc_features_get_enabled_bundles('group'));

  foreach ($group_entities as $entity_type) {

    $entity = entity_get_info($entity_type);
    $plugin['title'] = t('GCC group: group (@entity) member', array('@entity' => $entity['label']));
    $plugin['keyword'] = $entity_type;
    $plugin['description'] = t('Control access by the user membership state.');
    $plugin['name'] = $parent . ':' . $entity_type;
    $plugin['required context'] = new ctools_context_required(t(ucfirst($entity_type)), $entity_type);
    $plugins[$parent . ':' . $entity_type] = $plugin;
  }

  return $plugins;
}

/**
 * Check for access.
 */
function gcc_panels_gcc_group_member_access_check($conf, $context, $plugin) {

  list(, $group_entity_type) = explode(':', $plugin['name']);
  if (!$group_entity_type || empty($context->data)) {
    return FALSE;
  }

  $group_entity = $context->data;
  $info = entity_get_info($group_entity_type);
  $group_entity_id = isset($group_entity->{$info['entity keys']['id']}) ? $group_entity->{$info['entity keys']['id']} : NULL;

  return gcc_membership_is_active($group_entity_type, $group_entity_id, $GLOBALS['user']->uid);
}

/**
 * Provide a summary description.
 */
function gcc_panels_gcc_group_member_access_summary($conf, $context) {

  return t('Current user is member of the group');
}
