<?php

/**
 * @file
 * TODO.
 */

$plugin = array(

  'title' => t('GCC group: permission'),
  'description' => t("Control access by the user's group permission."),
  'callback' => 'gcc_panels_gcc_group_permission_access_check',
  'summary' => 'gcc_panels_gcc_group_permission_access_summary',
  'settings form' => 'gcc_panels_gcc_group_permission_access_settings',
  'settings form submit' => 'gcc_panels_gcc_group_permission_access_settings_submit',
  'default' => array('permissions' => array()),
  'get child' => 'gcc_panels_gcc_group_permission_access_get_child',
  'get children' => 'gcc_panels_gcc_group_permission_access_get_children',
);

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_permission_access_get_child($plugin, $parent, $child) {

  $plugins = gcc_panels_gcc_group_permission_access_get_children($plugin, $parent);

  return $plugins[$parent . ':' . $child];
}

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_permission_access_get_children($plugin, $parent) {

  $plugins = array();
  $group_entities = array_keys(gcc_features_get_enabled_bundles('group'));

  foreach ($group_entities as $entity_type) {

    $entity = entity_get_info($entity_type);
    $plugin['title'] = t('GCC group: group (@entity) member permission', array('@entity' => $entity['label']));
    $plugin['keyword'] = $entity_type;
    $plugin['description'] = t("Control access by the user's group permission.");
    $plugin['name'] = $parent . ':' . $entity_type;
    $plugin['required context'] = array(
      new ctools_context_required(t('Group'), $entity_type),
      new ctools_context_required(t('User'), 'user'),
    );
    $plugins[$parent . ':' . $entity_type] = $plugin;
  }

  return $plugins;
}

/**
 * Check for access.
 */
function gcc_panels_gcc_group_permission_access_check($conf, $context, $plugin) {

  list(,$group_entity_type) = explode(':', $plugin['name']);
  if (!$group_entity_type || empty($context) || empty($context[0]->data) || empty($context[1]->data) || !isset($conf['permissions'])) {
    return FALSE;
  }

  $group_entity = $context[0]->data;
  $group_member = $context[1]->data;

  foreach ($conf['permissions'] as $permission) {
    if (gcc_user_access($permission, $group_entity_type, $group_entity, $group_member)) {
      return TRUE;
    }
  }

  return FALSE;
}

function gcc_panels_gcc_group_permission_access_settings($form, &$form_state, $conf) {
  $permissions = array();
  foreach (gcc_permission_get_list() as $id => $permission) {
    $permissions[$id] = $permission['title'];
  }

  $form['settings']['permissions'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Group permissions'),
    '#options' => $permissions,
    '#default_value' => isset($conf['permissions']) ? $conf['permissions'] : array(),
    '#description' => t('Only the users with checked permissions will be granted access.'),
  );

  return $form;
}

function gcc_panels_gcc_group_permission_access_settings_submit($form, &$form_state) {
  $form_state['values']['settings']['permissions'] = array_keys(array_filter($form_state['values']['settings']['permissions']));
}

/**
 * Provide a summary description.
 */
function gcc_panels_gcc_group_permission_access_summary($conf, $context) {
  $permission_names = array();
  $permissions = gcc_permission_get_list();
  if (isset($conf['permissions'])) {
    foreach ($conf['permissions'] as $id) {
      $permission_name = isset($permissions[$id]) ? $permissions[$id]['title'] : '';
      $permission_names[] = $permission_name;
    }
  }
  return t("User's group permission is one of @permissions", array('@permissions' => implode(', ', $permission_names)));
}
