<?php

/**
 * @file
 * TODO.
 */

$plugin = array(

  'title' => t('GCC group: role'),
  'description' => t("Control access by the user's group role."),
  'callback' => 'gcc_panels_gcc_group_role_access_check',
  'summary' => 'gcc_panels_gcc_group_role_access_summary',
  'settings form' => 'gcc_panels_gcc_group_role_access_settings',
  'settings form submit' => 'gcc_panels_gcc_group_role_access_settings_submit',
  'default' => array('roles' => array()),
  'get child' => 'gcc_panels_gcc_group_role_access_get_child',
  'get children' => 'gcc_panels_gcc_group_role_access_get_children',
);

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_role_access_get_child($plugin, $parent, $child) {

  $plugins = gcc_panels_gcc_group_role_access_get_children($plugin, $parent);

  return $plugins[$parent . ':' . $child];
}

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_role_access_get_children($plugin, $parent) {

  $plugins = array();
  $group_entities = array_keys(gcc_features_get_enabled_bundles('group'));

  foreach ($group_entities as $entity_type) {

    $entity = entity_get_info($entity_type);
    $plugin['title'] = t('GCC group: group (@entity) member role', array('@entity' => $entity['label']));
    $plugin['keyword'] = $entity_type;
    $plugin['description'] = t("Control access by the user's group role.");
    $plugin['name'] = $parent . ':' . $entity_type;
    $plugin['required context'] = array(
      new ctools_context_required(t('Group'), $entity_type),
      new ctools_context_required(t('User'), 'user'),
    );
    $plugins[$parent . ':' . $entity_type] = $plugin;
  }

  return $plugins;
}

/**
 * Check for access.
 */
function gcc_panels_gcc_group_role_access_check($conf, $context, $plugin) {

  list(,$group_entity_type) = explode(':', $plugin['name']);
  if (!$group_entity_type || empty($context) || empty($context[0]->data) || empty($context[1]->data) || !isset($conf['roles'])) {
    return FALSE;
  }

  $group_entity = $context[0]->data;
  $group_member = $context[1]->data;
  $info = entity_get_info($group_entity_type);
  if (!$info) {
    return FALSE;
  }
  $group_entity_id = isset($group_entity->{$info['entity keys']['id']}) ? $group_entity->{$info['entity keys']['id']} : NULL;
  $roles = gcc_membership_get_roles($group_entity_type, $group_entity_id, $group_member->uid);

  return (count(array_intersect(array_keys($roles), $conf['roles'])) > 0);
}

function gcc_panels_gcc_group_role_access_settings($form, &$form_state, $conf) {
  $roles = array();
  foreach (gcc_role_get_list(GCC_GLOBAL_TYPE, GCC_GLOBAL_ID) as $role) {
    $roles[$role->rid] = $role->name;
  }

  $form['settings']['roles'] = array(
    '#type' => 'checkboxes',
    '#title' => t('Group roles'),
    '#options' => $roles,
    '#default_value' => isset($conf['roles']) ? $conf['roles'] : array(),
    '#description' => t('Only the checked roles will be granted access.'),
  );

  return $form;
}

function gcc_panels_gcc_group_role_access_settings_submit($form, &$form_state) {
  $form_state['values']['settings']['roles'] = array_keys(array_filter($form_state['values']['settings']['roles']));
}

/**
 * Provide a summary description.
 */
function gcc_panels_gcc_group_role_access_summary($conf, $context) {
  $role_names = array();
  $roles = gcc_role_get_list(GCC_GLOBAL_TYPE, GCC_GLOBAL_ID);
  if (isset($conf['roles'])) {
    foreach ($conf['roles'] as $rid) {
      $role_name = isset($roles[$rid]) ? $roles[$rid]->name : '';
      $role_names[] = $role_name;
    }
  }
  return t("User's group role is one of @roles", array('@roles' => implode(', ', $role_names)));
}
