<?php

/**
 * @file
 * TODO.
 */

$plugin = array(

  'title' => t("GCC group from group content"),
  'description' => t('Creates a group context from a group content; this will get the first group if multiple groups are selected.'),
  'context' => 'gcc_panels_gcc_group_from_content_context',
  'get child' => 'gcc_panels_gcc_group_from_content_get_child',
  'get children' => 'gcc_panels_gcc_group_from_content_get_children',
  'required context' => new ctools_context_required(t('Group content'), 'entity'),
);

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_from_content_get_child($plugin, $parent, $child) {

  $plugins = gcc_panels_gcc_group_from_content_get_children($plugin, $parent);
  return $plugins[$parent . ':' . $child];
}

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_from_content_get_children($plugin, $parent) {

  $group_entities = array_keys(gcc_features_get_enabled_bundles('group'));
  $plugins = array();
  foreach ($group_entities as $entity_type) {
    $entity = entity_get_info($entity_type);
    $plugin['title'] = t('GCC group (@entity) from group content', array('@entity' => $entity['label']));
    $plugin['keyword'] = $entity_type;
    $plugin['description'] = t('Creates a group context from a group content; this will get the first group if multiple groups are selected.');
    $plugin['name'] = $parent . ':' . $entity_type;
    $plugins[$parent . ':' . $entity_type] = $plugin;
  }

  return $plugins;
}

/**
 * Fixme : todo comment.
 */
function gcc_panels_gcc_group_from_content_context($context, $conf) {

  $plugin_name = $conf['name'];
  list(, $group_entity_type) = explode(':', $plugin_name);
  if ((!$group_entity_type) || (empty($context->data)) || (empty($context->data->{GCC_FIELD_AUDIENCE}))) {
    return ctools_context_create_empty($group_entity_type, NULL);
  }

  foreach ($context->data->{GCC_FIELD_AUDIENCE} as $values) {
    foreach ($values as $value) {
      if ($value['entity_type'] !== $group_entity_type) {
        continue;
      }
      $group_entity_id = $value['entity_id'];
      $group_entities = entity_load($group_entity_type, array($group_entity_id));
      if (empty($group_entities)) {
        continue;
      }
      $group = reset($group_entities);
      return ctools_context_create($group_entity_type, $group);
    }
  }

  return ctools_context_create_empty($group_entity_type, NULL);
}
