<?php
/**
 * @file
 */

class views_handler_join_relationship_users_roles extends views_join {

  /**
   * Build the SQL for the join this object represents.
   *
   * When possible, try to use table alias instead of table names.
   *
   * @param $select_query
   *   An implementation of SelectQueryInterface.
   * @param $table
   *   The base table to join.
   * @param $view_query
   *   The source query, implementation of views_plugin_query.
   */
  function build_join($select_query, $table, $view_query) {

    $left = $view_query->get_table_info($this->left_table);

    $extra = array();
    $extra[] = '(' . $left['alias'] . '.entity_type = ' . $table['alias'] . '.entity_type)';
    $extra[] = '(' . $left['alias'] . '.entity_id = ' . $table['alias'] . '.entity_id)';

    $this->extra = implode(' AND ', $extra);

    parent::build_join($select_query, $table, $view_query);
  }
}
